import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.control.ListView;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class FxListView extends Application {

    @Override
    public void start(Stage hauptStage) {
        ObservableList<MeineKlasse> meineDaten
                = FXCollections.observableArrayList();
        meineDaten.add(new MeineKlasse(10, "Aktiv"));
        meineDaten.add(new MeineKlasse(20, "Faul"));
        meineDaten.add(new MeineKlasse(30, "Tot"));
        ListView<MeineKlasse> listView
                = new ListView<MeineKlasse>(meineDaten);
        listView.getSelectionModel().selectedItemProperty()
                .addListener(
                new ChangeListener<MeineKlasse>() {

            @Override
            public void changed(
                    ObservableValue<? extends MeineKlasse>
                            observable,
                    MeineKlasse alt, MeineKlasse neu) {
                System.out.println("Alt: " + alt
                                + " Neu: " + neu);
            }
        });
        VBox pane = new VBox();
        pane.getChildren().add(listView);
        Scene scene = new Scene(pane, 250, 80);
        hauptStage.setScene(scene);
        hauptStage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
