import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.control.ListView;
import javafx.scene.control.SelectionMode;
import javafx.scene.layout.HBox;
import javafx.stage.Stage;

public class FxListViewMulti extends Application {

    @Override
    public void start(Stage stage) {
        ObservableList<String> eissorten =
                FXCollections.observableArrayList(
                    "Vanille", "Nuss", "Lakritz", "Zwiebel",
                    "Erdbeer", "Zitrone", "Anis", "Camembert");
        ListView<String> angebot = new ListView<>(eissorten);
        ListView<String> meinEis = new ListView<>();
        HBox pane = new HBox(angebot, meinEis);
        Scene scene = new Scene(pane);
        stage.setScene(scene);
        stage.show();
        // Ich darf mehrere Kugeln aussuchen
        angebot.getSelectionModel().setSelectionMode(
                SelectionMode.MULTIPLE);
        angebot.getSelectionModel().selectedIndexProperty()
                .addListener(new ChangeListener<Number>() {
            @Override
            public void changed(
                    ObservableValue<? extends Number> ob,
                    Number alt, Number neu) {
                // Setze alle ausgewählten in mein Eis
                meinEis.setItems(angebot.getSelectionModel()
                        .getSelectedItems());
            }
        });
    }

    public static void main(String[] args) {
        launch(args);
    }
}
