import java.io.RandomAccessFile;
import java.io.FileNotFoundException;
import java.io.IOException;

public class DBase {

    static final int DBFHEADER = 16;
    
    public static int getBetrag(byte wert) {
       return (wert < 0 ? -wert : wert);
    }

    static int getLittleEndian(byte[] data, int offset, int size) {
        int wert = 0;
        for (int i=size-1; i>=0; i--) {
        	wert *= 256;
        	wert += getBetrag(data[offset+i]);
        }
        return wert;
    }
    
    static public void main(String[] args) {
        // Speicherblock für den dBase-Header-Block
        byte [] dbfHeader = new byte[DBFHEADER];

        try {
            // lese den dBase-Header ein
            RandomAccessFile datei
                = new RandomAccessFile("test.dbf", "r");
            datei.read(dbfHeader);
            datei.close();
        } catch(FileNotFoundException e) {
            System.out.println("Datei nicht vorhanden.");
            System.exit(1);
        } catch(IOException e) {
            System.out.println("Dateifehler.");
            System.exit(2);
        }

        // Wie viele Daten stehen in der DBF-Datei?
        int recordZahl = getLittleEndian(dbfHeader, 4, 4);
        System.out.println("Anzahl der Records: " + recordZahl);
        // Wo beginnt der Datenbereich in der Datei?
        int offset = getLittleEndian(dbfHeader, 8, 2);
        System.out.println("Offset: " + offset);

        // Wie groß ist jeder Datenblock?
        int recordGroesse = getLittleEndian(dbfHeader, 10, 2);
        System.out.println("Record-Größe: " + recordGroesse);
        leseRecords(recordZahl, recordGroesse, offset);
    }
    
    static void leseRecords(int recordZahl, int recordGroesse, int offset) {
    	try {
    		byte[] dbfRecord = new byte[(int)recordGroesse];
    	    RandomAccessFile datei
    	            = new RandomAccessFile("test.dbf", "rw");
    	    for (int i=0; i<recordZahl; i++) {
    	        datei.seek(i*recordGroesse+offset);
    	        datei.read(dbfRecord);
    	        for (int j=0; j<recordGroesse; j++) {
    	            System.out.print((char)dbfRecord[j]);
    	        }
    	    }
    	    datei.close();
    	} catch(FileNotFoundException e) {
    	    System.out.println("Datei nicht vorhanden.");
    	} catch(IOException e) {
    	    System.out.println("Dateifehler.");
    	}
    }
    
}

