import java.io.File;

public class DirMainVisitor {

    public static void main(String[] args) {
        File file = new File(".");
        durchsuche(file, new DirAnzeigeVisitor());
        DirGroesseVisitor visitor = new DirGroesseVisitor();
        durchsuche(file, visitor);
        System.out.println(visitor.getGroesse());
    }

    static void durchsuche(File dir, DirVisitor visitor) {
        // Ist der übergebene Name ein Verzeichnis?
        if (dir.isDirectory()) {
            visitor.betreten(dir);
            File[] liste = dir.listFiles();
            for (File datei : liste) {
                if (datei.isDirectory()) {
                    // Verzeichnis! Aufruf der Rekursion!
                    durchsuche(datei, visitor);
                } else {
                    visitor.besuchen(datei);
                }
            }
            visitor.verlassen(dir);
        }
    }
}
