import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

public class InsertBonbon {
	final static String DBNAME = "Bonbonbude";
	final static String TABLENAME = "Artikel";

	public InsertBonbon() 
			throws ClassNotFoundException {
		// binde die Datenbank Derby ein
		Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
	}

	public static void main(String args[]) {
		Artikel lolly = new Artikel(
				"Blutwurstlutscher", 2.54, 120);
//				"Joghurt Hering/Maracuja", 2.78, 80);
		try {
			InsertBonbon bude = new InsertBonbon();
			Connection datenbank = bude.oeffneDB();
//			bude.insert(datenbank, lolly);
			Artikel[] liste = {
					new Artikel("Oreganodrops", 0.48, 30), 
					new Artikel("Senfpralinen", 0.78, 40), 
					new Artikel("Seifenschoko", 1.28, 20) 
				};
			//bude.insert(datenbank, liste);
			
			lolly.setPreis(0.87);
			bude.aendereNachName(datenbank, lolly);
			ArrayList<Artikel> list = bude.leseAlle(datenbank);
			for (Artikel artikel : list) {
				System.out.print(artikel.getName()+", ");
				System.out.print(artikel.getPreis()+", ");
				System.out.println(artikel.getMenge());
			}
			datenbank.close();
		} catch (SQLException e) {
			System.out.println(e.toString());
			System.out.println(e.getSQLState());
			System.out.println(e.getErrorCode());
		} catch (ClassNotFoundException e) {
			System.out.println("Derby-Jar fehlt.");
			e.printStackTrace();
		}
	}

    public ArrayList<Artikel> leseAlle(Connection db) throws SQLException {
    	ArrayList<Artikel> liste = new ArrayList<>();
    	Statement statement = db.createStatement();
    	ResultSet ergebnis = statement.executeQuery(
    			"SELECT name, preis, menge FROM artikel");
    	while (ergebnis.next()) {
    		liste.add(new Artikel(
    				ergebnis.getString("name"),
    				ergebnis.getDouble("preis"),
    				ergebnis.getInt("menge")));
    	}
    	ergebnis.close(); // Ergebnismenge schliessen
    	return liste;
    }

    void aendereNachName(Connection db, Artikel artikel)
    		throws SQLException  {
    	Statement statement = db.createStatement();
    	statement.execute("update "+ TABLENAME
                + " set preis=" + artikel.getPreis()
                + ",menge=" + artikel.getMenge()
                + " where name=\'"
                + artikel.getName() + "\'");
        statement.close();
    }
	void insertString(Connection db, Artikel artikel)
			throws SQLException {
		Statement statement = db.createStatement();
		statement.execute("insert into "+ TABLENAME
				+ " (name, preis, menge) VALUES "
				+ " (\'"+artikel.getName()+"\',"
				+ artikel.getPreis()+","
				+ artikel.getMenge()+" )");
		statement.close();
	}

	void insert(Connection db, Artikel artikel)
			throws SQLException {
		PreparedStatement befehl = db.prepareStatement(
				"insert into "+ TABLENAME
				+ " (name, preis, menge) VALUES (?,?,?)");
		befehl.setString(1, artikel.getName());
		befehl.setDouble(2,  artikel.getPreis());
		befehl.setInt(3, artikel.getMenge());
		befehl.executeUpdate();
		befehl.close();
	}
	
	void insert(Connection db, Artikel[] artikelliste)
			throws SQLException {
		PreparedStatement befehl = db.prepareStatement(
				"insert into "+ TABLENAME
				+ " (name, preis, menge) VALUES (?,?,?)");
		for (Artikel artikel : artikelliste) {
			befehl.setString(1, artikel.getName());
			befehl.setDouble(2,  artikel.getPreis());
			befehl.setInt(3, artikel.getMenge());
			befehl.executeUpdate();
		}
		befehl.close();
	}
	
	public Connection oeffneDB() throws SQLException {
		// Die Verbindungseigenschaften
		Properties properties = new Properties();
		properties.put("user", "superman");
		properties.put("password", "geheim");
		// Verbindung mit automatischer Erzeugung der DB
		Connection db = DriverManager.getConnection(
				"jdbc:derby:"+DBNAME, properties);
		return db;
	}

	public void erzeugeTabelle(Connection db) 
			throws SQLException {
		// Sende SQL-Befehl zur Erzeugung der Tabelle
		Statement statement = db.createStatement();
		statement.execute("create table " + TABLENAME 
				+ " ( name  varchar(32), " 
				+ " preis dec(10,2), "
				+ " menge int )");
		statement.close();
	}
}
