import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class ReadXml {

	public static void main(String[] argv) {
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse(new File("vokabel.xml"));
			// Wir holen das root-Element
			Node rootNode = document.getDocumentElement();
			NodeList nodeList = rootNode.getChildNodes();
			// Durchsuchen aller Unterknoten
			for (int i = 0; i < nodeList.getLength(); i++) {
				Node nodeChild = nodeList.item(i);
				zeigeNode(nodeChild);
			}
			// ---- Fehlerbehandlung ----
		} catch (SAXParseException spe) {
			System.out.println("Parse-Fehler Zeile: " + spe.getLineNumber() + ", uri " + spe.getSystemId());
			System.out.println("" + spe.getMessage());
			spe.printStackTrace();
		} catch (SAXException sxe) {
			sxe.printStackTrace();
		} catch (ParserConfigurationException pce) {
			pce.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}


	static void zeigeNode(Node node) {
		short typ = node.getNodeType();
		switch (typ) {
		case Node.ELEMENT_NODE:
			String sNodeName = node.getNodeName();
			System.out.println("NodeName: " + sNodeName);
			if (node.hasChildNodes()) { // Unterknoten?
				NodeList nodeList = node.getChildNodes();
				for (int i = 0; i < nodeList.getLength(); i++) {
					zeigeNode(nodeList.item(i));
				}
			}
			NamedNodeMap attribs = node.getAttributes();
			for (int i = 0; i < attribs.getLength(); i++) {
				Node attChild = attribs.item(i);
				zeigeNode(attChild); // rekursiv
			}
			break;
		case Node.ATTRIBUTE_NODE:
			System.out.print("Attribut: " + node.getNodeName());
			System.out.println(" Wert: " + node.getNodeValue());
			break;
		case Node.TEXT_NODE:
			String str = node.getTextContent();
			str = str.trim(); // störende Leerzeichen entfernen
			if (!str.isEmpty()) {
				System.out.println("Textinhalt: " + str);
			}
			break;
		case Node.NOTATION_NODE:
		case Node.COMMENT_NODE:
		case Node.DOCUMENT_NODE:
		default:
		}
	}
}
