import java.io.IOException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Scanner;
import org.json.JSONArray;
import org.json.JSONObject;

public class GeoGoogle {
    public static void main(String[] args) {
        try {
            String antwort = fragGoogleMaps("Munkbrarup");
            String adresse = werteJsonAntwortAus(antwort);
            System.out.println(adresse);
        } catch (IOException e) {
        }
    }
    static String fragGoogleMaps(String adresse) throws IOException {
        String urlStr = "http://maps.google.com/maps/api/geocode/json"
              + "?sensor=false&address=";
        urlStr += URLEncoder.encode(adresse, "UTF-8");
        URL url = new URL(urlStr);
        // hole die Antwort von Google-Maps ab
        Scanner scanner = new Scanner(url.openStream());
        String antwort = new String();
        while (scanner.hasNext()) {
            antwort += scanner.nextLine();
        }
        scanner.close();
        return antwort;
    }
    
    static String werteJsonAntwortAus(String antwort) {
        String ort = ""; 
        JSONObject jsonObj = new JSONObject(antwort);
        if (jsonObj.getString("status").equals("OK")) {
            JSONArray ergebnisse = jsonObj.getJSONArray("results");
            for (int i = 0; i < ergebnisse.length(); i++) {
                JSONObject obj = ergebnisse.getJSONObject(i);
                String ausgabe = obj.getString("formatted_address");
                JSONObject pos = obj.getJSONObject("geometry")
                        .getJSONObject("location");
                ausgabe += " (lat: " + pos.getDouble("lat");
                ausgabe += " lng: " + pos.getDouble("lng") + ")\n";
                ort += ausgabe;
            }
        }
        return ort;
    }

}
