import java.util.ArrayList;
import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONObject;

public class Person {
    private String name = "";
    private int alter = 0;
    ArrayList<String> instrumente = new ArrayList<String>();
    ArrayList<Sprache> sprachen = new ArrayList<Sprache>();

    public String getName() {
        return name;
    }

    public ArrayList<String> getInstrumente() {
        return instrumente;
    }

    public int getAlter() {
        return alter;
    }

    public ArrayList<Sprache> getSprachen() {
        return sprachen;
    }

    public Person() {
    }

    public Person(JSONObject jsonObject) {
        this.name = jsonObject.getString("name");
        this.alter = jsonObject.getInt("alter");
        JSONArray instrJson = jsonObject.getJSONArray("instrumente");
        for (int i=0; i<instrJson.length(); i++) {
        	instrumente.add(instrJson.getString(i));
        }
        JSONArray sprachenJson = jsonObject.getJSONArray("sprachen");
        for (int i=0; i<sprachenJson.length(); i++) {
            JSONObject jsonSprache = sprachenJson.getJSONObject(i);
            sprachen.add(new Sprache(jsonSprache));
        }
    }

	public void setName(String name) {
		this.name = name;
	}

	public void setAlter(int alter) {
		this.alter = alter;
	}
}

