import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.*;

public class Taschenrechner extends JFrame implements ActionListener {

    JTextField anzeige = null;
    String letzteAktion = "=";
    boolean loeschen = true;
    double ergebnis = 0.0;

    Taschenrechner() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new BorderLayout());

        String labels[] = {"9", "8", "7", "/",
                           "4", "5", "6", "*",
                           "1", "2", "3", "-",
                           "0", ".", "=", "+"};
        JPanel tastenfeld = new JPanel();
        tastenfeld.setLayout(new GridLayout(4,4));
        for (int i=0; i<labels.length; i++) {
            JButton button = new JButton(labels[i]);
            tastenfeld.add(button);
            button.addActionListener(this);
        }
        anzeige = new JTextField();
        add(BorderLayout.NORTH, anzeige);
        add(BorderLayout.CENTER, tastenfeld);
        // setSize(400, 300);
        pack();
        setVisible(true);
    }

    @Override public void actionPerformed(ActionEvent ev) {
        String str = ev.getActionCommand();
        // Achtung: switch ueber String geht erst ab Java 7!
        switch(str) {
        case "0": case "1": case "2":
        case "3": case "4": case "5":
        case "6": case "7": case "8":
        case "9": case ".":
            if (loeschen) {
                anzeige.setText("");
                loeschen = false;
            }
            str = anzeige.getText()+str;
            anzeige.setText(str);
            break;
        case "*": case "/": case "-": case "+": case "=":
            String strOperand = anzeige.getText();
            double operand = 0.0;
            if (!strOperand.isEmpty()) {
                operand = Double.parseDouble(strOperand);
            }
            loeschen = true;
            switch(letzteAktion) {
            case "*":
                ergebnis = ergebnis * operand;
                break;
            case "/":
                if (operand==0) {
                    ergebnis = 0;
                } else {
                    ergebnis = ergebnis / operand;
                }
                break;
            case "+":
                ergebnis = ergebnis + operand;
                break;
            case "-":
                ergebnis = ergebnis - operand;
                break;
            case "=": case " ":
                ergebnis = operand;
                break;
            }
            anzeige.setText("" + ergebnis);
            letzteAktion = str;
            break;
        }
    }
    public static void main(String[] args) {
       new Taschenrechner();
    }
}


